Panda3D

Public Member Functions | List of all members
TiXmlElement Class Reference

The element is a container class. More...

`#include "tinyxml.h"`

Inheritance diagram for TiXmlElement:

## Public Member Functions
| TiXmlElement (const char *in_value)
| Construct an element. More...
| TiXmlElement (const TiXmlElement &)
virtual bool | Accept (TiXmlVisitor *visitor) const
| Walk the XML tree visiting this node and all of its children. More...
const char * | Attribute (const char *name) const
| Given an attribute name, Attribute() returns the value for the attribute of that name, or null if none exists. More...
const char * | Attribute (const char *name, double *d) const
| Given an attribute name, Attribute() returns the value for the attribute of that name, or null if none exists. More...
const char * | Attribute (const char *name, int *i) const
| Given an attribute name, Attribute() returns the value for the attribute of that name, or null if none exists. More...
virtual TiXmlNode * | Clone () const
| Creates a new Element and returns it - the returned element is a copy. More...
TiXmlAttribute * | FirstAttribute ()
const TiXmlAttribute * | FirstAttribute () const
| Access the first attribute in this element. More...
const char * | GetText () const
| Convenience function for easy access to the text inside an element. More...
TiXmlAttribute * | LastAttribute ()
const TiXmlAttribute * | LastAttribute () const
| Access the last attribute in this element. More...
void | operator= (const TiXmlElement &base)
virtual const char * | Parse (const char *p, TiXmlParsingData *data, TiXmlEncoding encoding)
virtual void | Print (FILE *cfile, int depth) const
| All TinyXml classes can print themselves to a filestream or the string class (TiXmlString in non-STL mode, std::string in STL mode.) Either or both cfile and str can be null. More...
int | QueryDoubleAttribute (const char *name, double *_value) const
| QueryDoubleAttribute examines the attribute - see QueryIntAttribute(). More...
int | QueryFloatAttribute (const char *name, float *_value) const
| QueryFloatAttribute examines the attribute - see QueryIntAttribute(). More...
int | QueryIntAttribute (const char *name, int *_value) const
| QueryIntAttribute examines the attribute - it is an alternative to the Attribute() method with richer error checking. More...
void | RemoveAttribute (const char *name)
| Deletes an attribute with the given name. More...
void | SetAttribute (const char *name, const char *_value)
| Sets an attribute of name to a given value. More...
void | SetAttribute (const char *name, int value)
| Sets an attribute of name to a given value. More...
void | SetDoubleAttribute (const char *name, double value)
| Sets an attribute of name to a given value. More...
virtual TiXmlElement * | ToElement ()
| Cast to a more defined type. Will return null not of the requested type. More...
virtual const TiXmlElement * | ToElement () const
| Cast to a more defined type. Will return null not of the requested type. More...
Public Member Functions inherited from TiXmlNode
void | Clear ()
| Delete all the children of this node. Does not affect 'this'. More...
TiXmlNode * | FirstChild ()
const TiXmlNode * | FirstChild () const
| The first child of this node. Will be null if there are no children. More...
TiXmlNode * | FirstChild (const char *_value)
| The first child of this node with the matching 'value'. Will be null if none found. More...
const TiXmlNode * | FirstChild (const char *value) const
| The first child of this node with the matching 'value'. More...
TiXmlElement * | FirstChildElement ()
const TiXmlElement * | FirstChildElement () const
| Convenience function to get through elements. More...
TiXmlElement * | FirstChildElement (const char *_value)
const TiXmlElement * | FirstChildElement (const char *_value) const
| Convenience function to get through elements. More...
TiXmlDocument * | GetDocument ()
const TiXmlDocument * | GetDocument () const
| Return a pointer to the Document this node lives in. More...
TiXmlNode * | InsertAfterChild (TiXmlNode *afterThis, const TiXmlNode &addThis)
| Add a new node related to this. More...
TiXmlNode * | InsertBeforeChild (TiXmlNode *beforeThis, const TiXmlNode &addThis)
| Add a new node related to this. More...
TiXmlNode * | InsertEndChild (const TiXmlNode &addThis)
| Add a new node related to this. More...
TiXmlNode * | IterateChildren (const char *_value, const TiXmlNode *previous)
const TiXmlNode * | IterateChildren (const char *value, const TiXmlNode *previous) const
| This flavor of IterateChildren searches for children with a particular 'value'. More...
TiXmlNode * | IterateChildren (const TiXmlNode *previous)
const TiXmlNode * | IterateChildren (const TiXmlNode *previous) const
| An alternate way to walk the children of a node. More...
TiXmlNode * | LastChild ()
| The last child of this node. Will be null if there are no children. More...
const TiXmlNode * | LastChild () const
TiXmlNode * | LastChild (const char *_value)
| The last child of this node matching 'value'. Will be null if there are no children. More...
const TiXmlNode * | LastChild (const char *value) const
TiXmlNode * | LinkEndChild (TiXmlNode *addThis)
| Add a new node related to this. More...
TiXmlNode * | NextSibling ()
const TiXmlNode * | NextSibling () const
| Navigate to a sibling node. More...
const TiXmlNode * | NextSibling (const char *) const
| Navigate to a sibling node with the given 'value'. More...
TiXmlNode * | NextSibling (const char *_next)
TiXmlElement * | NextSiblingElement ()
const TiXmlElement * | NextSiblingElement () const
| Convenience function to get through elements. More...
const TiXmlElement * | NextSiblingElement (const char *) const
| Convenience function to get through elements. More...
TiXmlElement * | NextSiblingElement (const char *_next)
bool | NoChildren () const
| Returns true if this node has no children. More...
TiXmlNode * | Parent ()
| One step up the DOM. More...
const TiXmlNode * | Parent () const
TiXmlNode * | PreviousSibling ()
const TiXmlNode * | PreviousSibling () const
| Navigate to a sibling node. More...
const TiXmlNode * | PreviousSibling (const char *) const
| Navigate to a sibling node. More...
TiXmlNode * | PreviousSibling (const char *_prev)
bool | RemoveChild (TiXmlNode *removeThis)
| Delete a child of this node. More...
TiXmlNode * | ReplaceChild (TiXmlNode *replaceThis, const TiXmlNode &withThis)
| Replace a child of this node. More...
void | SetValue (const char *_value)
| Changes the value of the node. More...
virtual TiXmlComment * | ToComment ()
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual const TiXmlComment * | ToComment () const
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual TiXmlDeclaration * | ToDeclaration ()
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual const TiXmlDeclaration * | ToDeclaration () const
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual TiXmlDocument * | ToDocument ()
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual const TiXmlDocument * | ToDocument () const
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual TiXmlText * | ToText ()
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual const TiXmlText * | ToText () const
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual TiXmlUnknown * | ToUnknown ()
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual const TiXmlUnknown * | ToUnknown () const
| Cast to a more defined type. Will return null if not of the requested type. More...
int | Type () const
| Query the type (as an enumerated value, above) of this node. More...
const char * | Value () const
| The meaning of 'value' changes for the specific type of TiXmlNode. More...
const TiXmlString & | ValueTStr () const
Public Member Functions inherited from TiXmlBase
int | Column () const
| See Row() More...
void * | GetUserData ()
| Get a pointer to arbitrary user data. More...
const void * | GetUserData () const
| Get a pointer to arbitrary user data. More...
int | Row () const
| Return the position, in the original source file, of this node or attribute. More...
void | SetUserData (void *user)
| Set a pointer to arbitrary user data. More...

## Additional Inherited Members
Public Types inherited from TiXmlNode
enum | NodeType { TINYXML_DOCUMENT , TINYXML_ELEMENT , TINYXML_COMMENT , TINYXML_UNKNOWN , TINYXML_TEXT , TINYXML_DECLARATION , TINYXML_TYPECOUNT }
| The types of XML nodes supported by TinyXml. More...
Public Types inherited from TiXmlBase
enum | { TIXML_NO_ERROR = 0 , TIXML_ERROR , TIXML_ERROR_OPENING_FILE , TIXML_ERROR_PARSING_ELEMENT , TIXML_ERROR_FAILED_TO_READ_ELEMENT_NAME , TIXML_ERROR_READING_ELEMENT_VALUE , TIXML_ERROR_READING_ATTRIBUTES , TIXML_ERROR_PARSING_EMPTY , TIXML_ERROR_READING_END_TAG , TIXML_ERROR_PARSING_UNKNOWN , TIXML_ERROR_PARSING_COMMENT , TIXML_ERROR_PARSING_DECLARATION , TIXML_ERROR_DOCUMENT_EMPTY , TIXML_ERROR_EMBEDDED_NULL , TIXML_ERROR_PARSING_CDATA , TIXML_ERROR_DOCUMENT_TOP_ONLY , TIXML_ERROR_STRING_COUNT }
Static Public Member Functions inherited from TiXmlBase
static void | EncodeString (const TiXmlString &str, TiXmlString *out)
| Expands entities in a string. More...
static bool | IsWhiteSpaceCondensed ()
| Return the current white space setting. More...
static void | SetCondenseWhiteSpace (bool condense)
| The world does not agree on whether white space should be kept or not. More...
Static Public Attributes inherited from TiXmlBase
static const int | utf8ByteTable [256]

## Detailed Description

The element is a container class.

It has a value, the element name, and can contain other elements, text, comments, and unknowns. Elements also contain an arbitrary number of attributes.

Definition at line 940 of file tinyxml.h.

## Constructor & Destructor Documentation

## ◆ TiXmlElement()

TiXmlElement::TiXmlElement | ( | const char * | in_value | ) |

Construct an element.

Definition at line 543 of file tinyxml.cpp.

References TiXmlElement().

Referenced by TiXmlElement().

## Member Function Documentation

## ◆ Accept()

bool TiXmlElement::Accept | ( | TiXmlVisitor * | visitor | ) | const
| virtual

Walk the XML tree visiting this node and all of its children.

Implements TiXmlNode.

Definition at line 853 of file tinyxml.cpp.

References TiXmlNode::Accept(), TiXmlNode::FirstChild(), TiXmlNode::NextSibling(), TiXmlVisitor::VisitEnter(), and TiXmlVisitor::VisitExit().

## ◆ Attribute() [1/3]

const char * TiXmlElement::Attribute | ( | const char * | name | ) | const

Given an attribute name, Attribute() returns the value for the attribute of that name, or null if none exists.

Definition at line 594 of file tinyxml.cpp.

References TiXmlAttribute::Value().

## ◆ Attribute() [2/3]

const char * TiXmlElement::Attribute | ( | const char * | name,
|  | double * | d
| ) |  | const

Given an attribute name, Attribute() returns the value for the attribute of that name, or null if none exists.

If the attribute exists and can be converted to an double, the double value will be put in the return 'd', if 'd' is non-null.

Definition at line 646 of file tinyxml.cpp.

References TiXmlAttribute::QueryDoubleValue(), and TiXmlAttribute::Value().

## ◆ Attribute() [3/3]

const char * TiXmlElement::Attribute | ( | const char * | name,
|  | int * | i
| ) |  | const

Given an attribute name, Attribute() returns the value for the attribute of that name, or null if none exists.

If the attribute exists and can be converted to an integer, the integer value will be put in the return 'i', if 'i' is non-null.

Definition at line 614 of file tinyxml.cpp.

## ◆ Clone()

TiXmlNode * TiXmlElement::Clone | ( |  | ) | const
| virtual

Creates a new Element and returns it - the returned element is a copy.

Implements TiXmlNode.

Definition at line 867 of file tinyxml.cpp.

References TiXmlNode::Value().

## ◆ FirstAttribute()

const TiXmlAttribute* TiXmlElement::FirstAttribute | ( |  | ) | const
| inline

Access the first attribute in this element.

Definition at line 1077 of file tinyxml.h.

## ◆ GetText()

const char * TiXmlElement::GetText | ( |  | ) | const

Convenience function for easy access to the text inside an element.

Although easy and concise, GetText() is limited compared to getting the TiXmlText child and accessing it directly.

If the first child of 'this' is a TiXmlText, the GetText() returns the character string of the Text node, else null is returned.

This is a convenient method for getting the text of simple contained text:

    <foo>This is text</foo>
    const char* str = fooElement->GetText();

'str' will be a pointer to "This is text".

Note that this function can be misleading. If the element foo was created from this XML:

    <foo><b>This is text</b></foo>

then the value of str would be null. The first child node isn't a text node, it is another element. From this XML:

    <foo>This is <b>text</b></foo>

GetText() will return "This is ".

WARNING: GetText() accesses a child node - don't become confused with the similarly named TiXmlHandle::Text() and TiXmlNode::ToText() which are safe type casts on the referenced node.

Definition at line 878 of file tinyxml.cpp.

References TiXmlNode::FirstChild(), TiXmlNode::ToText(), and TiXmlNode::Value().

## ◆ LastAttribute()

const TiXmlAttribute* TiXmlElement::LastAttribute | ( |  | ) | const
| inline

Access the last attribute in this element.

Definition at line 1079 of file tinyxml.h.

## ◆ Print()

void TiXmlElement::Print | ( | FILE * | cfile,
|  | int | depth
| ) |  | const
| virtual

All TinyXml classes can print themselves to a filestream or the string class (TiXmlString in non-STL mode, std::string in STL mode.) Either or both cfile and str can be null.

This is a formatted print, and will insert tabs and newlines.

(For an unformatted stream, use the << operator.)

Implements TiXmlBase.

Definition at line 778 of file tinyxml.cpp.

## ◆ QueryDoubleAttribute()

int TiXmlElement::QueryDoubleAttribute | ( | const char * | name,
|  | double * | _value
| ) |  | const

QueryDoubleAttribute examines the attribute - see QueryIntAttribute().

Definition at line 698 of file tinyxml.cpp.

References TiXmlAttribute::QueryDoubleValue().

Referenced by QueryFloatAttribute().

## ◆ QueryFloatAttribute()

int TiXmlElement::QueryFloatAttribute | ( | const char * | name,
|  | float * | _value
| ) |  | const
| inline

QueryFloatAttribute examines the attribute - see QueryIntAttribute().

Definition at line 989 of file tinyxml.h.

References QueryDoubleAttribute().

## ◆ QueryIntAttribute()

int TiXmlElement::QueryIntAttribute | ( | const char * | name,
|  | int * | _value
| ) |  | const

QueryIntAttribute examines the attribute - it is an alternative to the Attribute() method with richer error checking.

If the attribute is an integer, it is stored in 'value' and the call returns TIXML_SUCCESS. If it is not an integer, it returns TIXML_WRONG_TYPE. If the attribute does not exist, then TIXML_NO_ATTRIBUTE is returned.

Definition at line 678 of file tinyxml.cpp.

References TiXmlAttribute::QueryIntValue().

## ◆ RemoveAttribute()

void TiXmlElement::RemoveAttribute | ( | const char * | name | ) |

Deletes an attribute with the given name.

Definition at line 455 of file tinyxml.cpp.

## ◆ SetAttribute() [1/2]

void TiXmlElement::SetAttribute | ( | const char * | name,
|  | const char * | _value
| ) |  |

Sets an attribute of name to a given value.

The attribute will be created if it does not exist, or changed if it does.

Definition at line 758 of file tinyxml.cpp.

References TiXmlAttribute::SetValue().

## ◆ SetAttribute() [2/2]

void TiXmlElement::SetAttribute | ( | const char * | name,
|  | int | value
| ) |  |

Sets an attribute of name to a given value.

The attribute will be created if it does not exist, or changed if it does.

Definition at line 718 of file tinyxml.cpp.

References TiXmlAttribute::SetIntValue().

## ◆ SetDoubleAttribute()

void TiXmlElement::SetDoubleAttribute | ( | const char * | name,
|  | double | value
| ) |  |

Sets an attribute of name to a given value.

The attribute will be created if it does not exist, or changed if it does.

Definition at line 738 of file tinyxml.cpp.

References TiXmlAttribute::SetDoubleValue().

## ◆ ToElement() [1/2]

virtual TiXmlElement* TiXmlElement::ToElement | ( |  | ) |
| inline virtual

Cast to a more defined type. Will return null not of the requested type.

Reimplemented from TiXmlNode.

Definition at line 1127 of file tinyxml.h.

## ◆ ToElement() [2/2]

virtual const TiXmlElement* TiXmlElement::ToElement | ( |  | ) | const
| inline virtual

Cast to a more defined type. Will return null not of the requested type.

Reimplemented from TiXmlNode.

Definition at line 1126 of file tinyxml.h.

The documentation for this class was generated from the following files:

- panda/src/dxml/tinyxml.h
- panda/src/dxml/tinyxml.cpp
- panda/src/dxml/tinyxmlparser.cpp